<template lang="pug">
  .store

    // For admin

    .btn-group.align-items-center.d-flex.mb-2
      button.btn.btn-outline-danger(
      @click='removeFromArray'
      v-show='adminMode'
      )
        | &times Del last product &times
      button.btn.btn-outline-danger(
      @click='addNewProduct'
      v-show='adminMode'
      )
        | + Add new product +
        span.addDescription random from category

      button.btn.btn-outline-danger.font-weight-bold(
      @click='toDefault'
      v-show='adminMode'
      )
        | &laquo Back to default &laquo
      button.btn.btn-outline-danger(
      @click='changeMode'
      :class='{ adminBorderRadius: !adminMode }'
      )
        | &#10031; {{ adminName }} &#10031;

    // Products

    transition-group.row.list__ul(name='storeProd')
      .product.col-sm-6.col-lg-3(
      v-for='(item, index) in items'
      :key='item.id'
      )
        .into-col.text-center

          button.remove-it.mb-2.float-right.btn.btn-sm.btn-danger(
          @click='removeItemProduct(index)'
          v-show='adminMode'
          )
            | remove it

          img.img-responsive(
          :src='item.image'
          alt='product'
          )

          h5 {{ item.title }}

          h6 {{ item.price | currency }}

          .d-flex.justify-content-between.align-items-center.px-3.row
            .text-input.btn-group

              button.btn.btn-outline-light(
              v-bind:disabled='adminMode'
              @click='storeProdDecrement(item)'
              )

              input.quantity.form-control.input-qty.form-control-sm.input-products(
              v-bind:disabled='adminMode'
              @keyup='inputControl(item)'
              min='1'
              onkeypress=' return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57'
              maxlength='2'
              v-model='item.qty'
              type='text'
              value='1'
              )

              button.btn.btn-outline-light.plus(
              :disabled='adminMode'
              @click='storeProdIncrement(item)'
              )

            button.btn.btn-sm.btn-info(
            :disabled='adminMode'
            @click='addToCart(item)'
            )
              | Add to Cart
</template>

<script>
  export default {
    name: "Store",
    props: {
      cartItems: {
        type: Array,
        default: () => []
      },
      storeFactor: {
        type: String,
      },
      isRand: {
        type: Boolean
      },
      toDisableCart: {
        type: Boolean
      }
    },

    data() {
      return {
        items: [
          {
            id: 1 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-8',
            price: 2500,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 1 + '.jpg' :
              'http://lorempixel.com/450/350/abstract'
          },
          {
            id: 2 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-7',
            price: 1030,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 2 + '.jpg' :
              'http://lorempixel.com/450/350/animals'
          },
          {
            id: 3 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-6',
            price: 1250,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 3 + '.jpg' :
              'http://lorempixel.com/450/350/business'
          },
          {
            id: 4 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-5',
            price: 1120,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 4 + '.jpg' :
              'http://lorempixel.com/450/350/cats'
          },
          {
            id: 5 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-4',
            price: 1120,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 5 + '.jpg' :
              'http://lorempixel.com/450/350/city'
          },
          {
            id: 6 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-3',
            price: 1120,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 6 + '.jpg' :
              'http://lorempixel.com/450/350/food'
          },
          {
            id: 7 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-2',
            price: 2276,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 7 + '.jpg' :
              'http://lorempixel.com/450/350/nightlife'
          },
          {
            id: 8 + this.storeFactor,
            sort: '',
            title: this.storeFactor + '-1',
            price: 1450,
            qty: 1,
            image: !this.isRand ?
              'static/' + this.storeFactor + '/pic-' + 8 + '.jpg' :
              'http://lorempixel.com/450/350/fashion'
          }
        ],
        defaultFirstItems: [],
        adminMode: false,
        deletingFactor: 0,
        newId: '',
        newProd: 9
      }
    },

    methods: {

      // Addition to CART

      addToCart(index) {
        let foundTwin = false
        this.cartItems.forEach(item => {
          if (item.id === index.id) {
            foundTwin = true
            item.sort = new Date().getTime()
            item.qty = Number(item.qty)
            item.qty += Number(index.qty)

            // ↓ Sort products in cartItems by the time
            return this.cartItems.sort((a, b) => b.sort - a.sort)
          }
        })

        if (foundTwin === false) {
          index.sort = new Date().getTime()
          this.cartItems.push(Vue.util.extend({}, index))

          // ↓ Sort products in cartItems by the time
          this.cartItems.sort((a, b) => b.sort - a.sort)

          let parsed = JSON.stringify(this.cartItems)
          localStorage.setItem("cartItems", parsed)
          return this.cartItems.sort((a, b) => b.sort - a.sort)
        }

        index.qty = 1;
        this.toLocalStorage()
        let parsed = JSON.stringify(this.cartItems)
        localStorage.setItem("cartItems", parsed)
      },

      //  Remove excess product by admin

      removeItemProduct(index) {
        this.items.splice(index, 1)
        this.deletingFactor++
        this.toLocalStorage()
      },

      // For Products in Store  (use LocalStorage)

      addNewProduct() {
        this.newId = this.items.length + this.deletingFactor
        this.newId++;
        let randNewProd = Math.floor(Math.random() * (33 - 1)) + 1 // random price for new product
        let randPrice = Math.floor(Math.random() * (3000 - 1000)) + 1000 // random price for new product
        this.items.unshift({
          id: this.newId += this.storeFactor,
          sort: '',
          title: this.storeFactor + '-' + this.newProd,
          price: randPrice,
          qty: 1,
          image: !this.isRand ?
            'static/' + this.storeFactor + '/pic-' + randNewProd + '.jpg' :
            'http://lorempixel.com/450/350/'
        });
        this.newProd++
        this.toLocalStorage()
      },

      removeFromArray() {
        this.items.pop()
        if (this.newId > 1) this.newId--
        if (this.newProd > 1) this.newProd--
        this.toLocalStorage()
      },

      toDefault() {
        this.items.splice(0, this.items.length)
        for (let i = 0; i < 8; i++) {
          this.items[i] = this.defaultFirstItems[i]
        }
        this.toLocalStorage()
      },

      // For custom elements in inputs

      storeProdDecrement(index) {
        this.items.forEach(item => {
          if (item.id === index.id && index.qty > 1) {
            item.qty--
          }
        })
      },

      storeProdIncrement(index) {
        this.items.forEach(item => {
          if (item.id === index.id && index.qty < 99) {
            item.qty++
          }
        })
      },

      inputControl(index) {
        this.items.forEach(item => {
          if (item.id === index.id && item.qty == 0) {
            item.qty = 1
          }
        })
      },

      // Transforming common array to individual array for each individual category and save into LocalStorage

      toLocalStorage() {
        let categoryItems
        categoryItems = this.items + this.storeFactor
        let parsed = JSON.stringify(this.items)
        localStorage.setItem('categoryItems' + '-' + this.storeFactor, parsed)
      },

      // Change admin mode

      changeMode() {
        this.adminMode = !this.adminMode
        this.$emit('changeAdminMode', this.adminMode)
      }
    },

    computed: {
      adminName() {
        return this.adminMode ? 'Exit from Admin Mode' : 'Enter Admin Mode'
      }
    },

    mounted() {

      // Remembering default products

      for (let i = 0; i < 8; i++) {
        this.defaultFirstItems[i] = this.items[i]
      }

      // Getting products array from LocalStorage

      if (localStorage.getItem('categoryItems' + '-' + this.storeFactor)) {
        try {
          this.items = JSON.parse(localStorage.getItem('categoryItems' + '-' + this.storeFactor))
        } catch (e) {
          localStorage.removeItem('categoryItems' + '-' + this.storeFactor)
        }
      }
    }
  }
</script>

<style lang="scss" scoped>

  .storeProd-enter {
    transform: translateX(calc(20vw - 11%)) rotate(-145deg) scale(0.001);
  }

  .storeProd-enter-active {
    transition: all .6s cubic-bezier(0.23, 1, 0.32, 1)
  }

  .storeProd-leave-to {
    transform: translateX(calc(20vw - 11%)) rotate(-180deg) scale(0.001);
    z-index: -2;
  }

  .storeProd-leave-active {
    transition: all .6s cubic-bezier(0.23, 1, 0.32, 1);
    position: absolute;
  }

  .storeProd-move {
    transition: all 1s cubic-bezier(0.23, 1, 0.32, 1)
  }

  .product {
    padding: 13px;

    .remove-it {
      position: absolute;
      right: 3px;
      top: 2px;
    }

    .into-col {
      background: #e2e2e2;
      border: 1px solid #b3b7bb;
      padding: 7px;
      border-radius: 4px;
    }

    .into-col img {
      border-radius: 4px;
      margin-bottom: 10px;
      width: calc(100%);
    }

    .input-products {
      width: calc(2rem + 10px);
      margin-right: 1px;
    }

    h5:first-letter {
      text-transform: capitalize;
    }

    input[type="text"] {
      -webkit-appearance: textfield;
      -moz-appearance: textfield;
      appearance: textfield;
      font-size: 20px;
      border: 1px solid #ffffff;
      font-weight: 600;
      background: #fbfbfb;
      margin: 0 -2px;
    }

    input[type=text]::-webkit-inner-spin-button,
    input[type=text]::-webkit-outer-spin-button {
      -webkit-appearance: none;
    }

    .text-input {
      border: 2px solid #ddd;
      display: inline-flex;
    }

    .text-input,
    .text-input * {
      box-sizing: border-box;
    }

    .text-input {
      button {
        outline: none;
        -webkit-appearance: none;
        border: 1px solid #fff;
        align-items: center;
        justify-content: center;
        cursor: pointer;
        margin: 0;
        position: relative;

        &:hover {
          background: #dadada;
        }

        &:active {
          background: #17a2b8;
        }

        &:before, &:after {
          display: inline-block;
          position: absolute;
          content: '';
          width: 1rem;
          height: 2px;
          background-color: #212121;
          transform: translate(-50%, -50%);
        }
      }
    }

    .text-input button.plus:after {
      transform: translate(-50%, -50%) rotate(90deg);
    }
  }

  .adminBorderRadius {
    border-radius: 0.25rem !important;
  }

  .addDescription {
    font-size: 11px;
    position: absolute;
    display: inline-block;
    right: 4px;
    border: 1px solid #dc3545;
    border-radius: 4px;
    top: -40%;
    background: #ff6a6a;
    padding: 0 4px;
    color: #fff;
  }

</style>
